Subject: Re: [PATCH] Performance Stats: Kernel patch

From: Andrew Morton <[email-masked]>
Date: Thu, 10 May 2007 11:12:42 -0700

On Thu, 10 May 2007 11:11:18 +0000 Maxim Uvarov <[email-masked]> wrote:

> >syscall entry is a super-hotpath and there will be a developer revolt
> >if we go adding an incl to that path, sorry.
> >
> >  
> >
> Yes, I know that it is very critical part of code. May be protection with
> ifdef CONFIG_TASKSTATS  in all entry.S can be solution?
> In that case we can be sure that nothing wrong can not happen,
> and if this functionality is needed we can turn on this.

I very much hope that all distributors will enable taskstats, so that won't
help.

I don't think the syscall-counting feature has a future, sorry.  Perhaps
you could do something like hooking it up on-demand by insertion of a kprobe,
dunno.

> >(Did that incl also cover the int 80 entry?)
> >  
> >
> Actually not. But counter increments each time when syscall  calls.
> But it is in very save place, just after
>         SAVE_ALL
>         GET_THREAD_INFO(%ebp)
> So it is very hard to break something.
> 

What I meant was: the code appears to be counting sysenter-invoked syscalls,
but it isn't counting not int 80-invoked syscalls.